#include <bits/stdc++.h>
#include "swrace.h"
#define NONE -1
#define R 0
#define U 1
#define L 2
#define D 3
#define WHITE 4
#define BLACK 5
#define SEED 99
using namespace std;

ifstream in("input.txt");
ofstream out("output.txt");

default_random_engine myengine = default_random_engine(SEED);

struct nodo{
    int x;
    int y;
    int color = NONE;
    int move = NONE; 
    bool visited = false;
    // bool operator < (nodo a) const {}
};

 // ordinato in modo che, sommando DIFFS[d] ad un punto, mi muovo in direzione d
vector<pair<int,int>> DIFFS = {make_pair(0,1),make_pair(-1,0),make_pair(0,-1),make_pair(1,0)};

vector<char> fromIntToDirection = {'R','U','L','D'};

// vettore che può essere riordinato in modo random ed usato per muoversi in direzioni casuali
vector<int> dir = {R,U,L,D};

int N, M, B, W;
vector<vector<nodo>> grid;

////// tools per muoversi sulla griglia //////
bool areValidCoords(int x, int y){
    return (x>=0 && x<N && y>=0 && y<M);
}

bool areValidNotVisited(int x, int y){
    if(!areValidCoords(x,y))
    	return false;
    return !grid[x][y].visited; 
}

int reverseDirection(int d){ // al momento inutilizzata
    return (d+2)%4;
}

// salva in opposite le direzioni ad "angolo" rispetto a d
void oppositeDirections(int d, vector<int>& opposite){ 
	opposite.resize(2);
	if(d == R || d == L){ opposite[0] = U; opposite[1] = D; } 
	else{ opposite[0] = R; opposite[1] = L; }
	shuffle(opposite.begin(), opposite.end(), myengine);
}

////// funzioni muoversi sulla griglia ed attraversare correttamente le biglie //////

bool fromBlackGoOn(pair<int,int> &point, int d);
bool fromWhiteGoOn(pair<int,int> &point, int d, bool changeDirection);
bool findBlack(pair<int,int> &point);
bool findWhite(pair<int,int> &point);

// Cerca di trovare una biglia nera muovendoti di due passi in una direzione
bool findBlack(pair<int,int> &point){
	int x[5], y[5];
	x[0] = point.first, y[0] = point.second; 
	if(grid[x[0]][y[0]].visited)
		return false;
	shuffle(dir.begin(), dir.end(), myengine);
	for(auto d : dir){
		// mi muovo di due passi nella direzione d, cercando una biglia nera
		x[1] = x[0]+DIFFS[d].first, y[1] = y[0]+DIFFS[d].second;
		x[2] = x[1]+DIFFS[d].first, y[2] = y[1]+DIFFS[d].second;
		if(areValidNotVisited(x[1],y[1]) && areValidNotVisited(x[2],y[2])){
			if(grid[x[2]][y[2]].color == BLACK && grid[x[1]][y[1]].color != BLACK){ // posso passare anche da una biglia bianca in (x1,y1)
				vector<int> opposite; 
				oppositeDirections(d,opposite);
				for(auto o : opposite){
					point = make_pair(x[2],y[2]);
					grid[x[0]][y[0]].visited = true;
					grid[x[1]][y[1]].visited = true;
					if(fromBlackGoOn(point,o)){ 
						// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x2,y2):
						grid[x[0]][y[0]].move = d;
						grid[x[1]][y[1]].move = d;
						return true;
					}
					grid[x[0]][y[0]].visited = false;
					grid[x[1]][y[1]].visited = false;
				}
			}
		}
	}
	point = make_pair(x[0],y[0]); // reset
	return false;
}

// Cerca di trovare una biglia bianca muovendoti di un passo in una direzione
bool findWhite(pair<int,int> &point){
	int x[5], y[5];
	x[0] = point.first, y[0] = point.second; 
	if(grid[x[0]][y[0]].visited)
		return false;
	shuffle(dir.begin(), dir.end(), myengine);
	for(auto d : dir){
		// mi muovo di un passo nella direzione d, cercando una biglia bianca
		x[1] = x[0]+DIFFS[d].first, y[1] = y[0]+DIFFS[d].second;
		if(areValidNotVisited(x[1],y[1])){
			if(grid[x[1]][y[1]].color == WHITE){
				point = make_pair(x[1],y[1]);
				grid[x[0]][y[0]].visited = true;
				if(fromWhiteGoOn(point,d,true)){
					// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x1,y1):
					grid[x[0]][y[0]].move = d;
					return true;
				}
				grid[x[0]][y[0]].visited = false;
			}
		}
	}
	point = make_pair(x[0],y[0]);
	return false;
}

// Dalla posizione (x0,y0), che contiene un cerchio bianco, vai avanti lungo la direzione d
// e gira se changeDirection è true
bool fromWhiteGoOn(pair<int,int> &point, int d, bool changeDirection){
	int x[5], y[5];
	x[0] = point.first, y[0] = point.second;
	x[1] = x[0]+DIFFS[d].first, y[1] = y[0]+DIFFS[d].second;
	if(areValidNotVisited(x[0],y[0]) && areValidNotVisited(x[1],y[1])){

		if(grid[x[1]][y[1]].color == NONE && !changeDirection){
			grid[x[0]][y[0]].move = d, grid[x[0]][y[0]].visited = true;
			point = make_pair(x[1],y[1]); 
			return true;
		}

		if(grid[x[1]][y[1]].color == NONE && changeDirection){
			vector<int> opposite; 
			oppositeDirections(d,opposite);
			for(auto o : opposite){
				x[2] = x[1]+DIFFS[o].first, y[2] = y[1]+DIFFS[o].second;
				if(areValidNotVisited(x[2],y[2])){
					if(grid[x[2]][y[2]].color == NONE){
						grid[x[0]][y[0]].move = d, grid[x[0]][y[0]].visited = true;
						grid[x[1]][y[1]].move = o, grid[x[1]][y[1]].visited = true;
						point = make_pair(x[2],y[2]);  
						return true;
					}
					if(grid[x[2]][y[2]].color == WHITE){
						point = make_pair(x[2],y[2]);
						grid[x[0]][y[0]].visited = true;
						grid[x[1]][y[1]].visited = true;
						if(fromWhiteGoOn(point,o,false)){ 
							// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x2,y2):
							grid[x[0]][y[0]].move = d;
							grid[x[1]][y[1]].move = o;
							return true;
						}
						grid[x[0]][y[0]].visited = false;
						grid[x[1]][y[1]].visited = false;
					}
				}
			}
			point = make_pair(x[0],y[0]);
			return false;	
		}

		if(grid[x[1]][y[1]].color == BLACK){
			vector<int> opposite; 
			oppositeDirections(d,opposite);
			for(auto o : opposite){
				point = make_pair(x[1],y[1]);
				grid[x[0]][y[0]].visited = true;
				if(fromBlackGoOn(point,o)){
					// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x1,y1):
					grid[x[0]][y[0]].move = d;
					return true;
				}
				grid[x[0]][y[0]].visited = false;
			}
			point = make_pair(x[0],y[0]);
			return false;
		}

		if(grid[x[1]][y[1]].color == WHITE && changeDirection){
			point = make_pair(x[0],y[0]);
			return false;
		}

		if(grid[x[1]][y[1]].color == WHITE && !changeDirection){
			point = make_pair(x[1],y[1]);
			grid[x[0]][y[0]].visited = true;
			if(fromWhiteGoOn(point,d,true)){
				// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x1,y1):
				grid[x[0]][y[0]].move = d;
				return true;
			}
			grid[x[0]][y[0]].visited = false;
		}
		
	}
	point = make_pair(x[0],y[0]);
	return false;
}

// Dalla posizione (x0,y0), che contiene un cerchio nero, vai avanti lungo la direzione d (di due step)
bool fromBlackGoOn(pair<int,int> &point, int d){
	int x[5], y[5];
	x[0] = point.first, y[0] = point.second;
	x[1] = x[0]+DIFFS[d].first, y[1] = y[0]+DIFFS[d].second;
	x[2] = x[1]+DIFFS[d].first, y[2] = y[1]+DIFFS[d].second;
	if(areValidNotVisited(x[0],y[0]) && areValidNotVisited(x[1],y[1]) && areValidNotVisited(x[2],y[2])){

		if(grid[x[1]][y[1]].color == BLACK){
			point = make_pair(x[0],y[0]);
			return false;
		}

		if(grid[x[1]][y[1]].color == NONE && grid[x[2]][y[2]].color == NONE){
			grid[x[0]][y[0]].move = d, grid[x[0]][y[0]].visited = true;
			grid[x[1]][y[1]].move = d, grid[x[1]][y[1]].visited = true;
			point = make_pair(x[2],y[2]);
			return true;
		}

		if(grid[x[1]][y[1]].color == WHITE){
			point = make_pair(x[1],y[1]);
			grid[x[0]][y[0]].visited = true;
			if(fromWhiteGoOn(point,d,false)){
				// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x1,y1):
				grid[x[0]][y[0]].move = d;
				return true;
			}
			grid[x[0]][y[0]].visited = false;
		}

		if(grid[x[2]][y[2]].color == WHITE){
			point = make_pair(x[2],y[2]);
			grid[x[0]][y[0]].visited = true;
			grid[x[1]][y[1]].visited = true;
			if(fromWhiteGoOn(point,d,true)){
				// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x2,y2):
				grid[x[0]][y[0]].move = d;
				grid[x[1]][y[1]].move = d;
				return true;
			}
			grid[x[0]][y[0]].visited = false;
			grid[x[1]][y[1]].visited = false;
		}

		if(grid[x[2]][y[2]].color == BLACK){
			vector<int> opposite; 
			oppositeDirections(d,opposite);
			for(auto o : opposite){
				point = make_pair(x[2],y[2]);
				grid[x[0]][y[0]].visited = true;
				grid[x[1]][y[1]].visited = true;
				if(fromBlackGoOn(point,o)){
					// se vero, point viene aggiornato, restano da scrivere le mosse per arrivare in (x2,y2):
					grid[x[0]][y[0]].move = d;
					grid[x[1]][y[1]].move = d;
					return true;
				}
				grid[x[0]][y[0]].visited = false;
				grid[x[1]][y[1]].visited = false;
			}
		}
		
	}
	point = make_pair(x[0],y[0]);
	return false;
}


void solve(pair<int,int> &point){
	bool moveBlack = false, moveWhite = false, moveRandom = false;
	do{
		moveBlack = false, moveWhite = false, moveRandom = false;
		moveBlack = findBlack(point);
		if(moveBlack){
			// cout << "at least one black taken, moved to " << point.first << " " << point.second << endl;
		}
		else{
			moveWhite = findWhite(point);
			if(moveWhite){
				// cout << "at least one white taken, moved to " << point.first << " " << point.second << endl;
			}
			else{
				shuffle(dir.begin(), dir.end(), myengine);
				int d = 0;
				int x, y;
				do{
					x = point.first+DIFFS[dir[d]].first;
					y = point.second+DIFFS[dir[d]].second;
					if(!areValidNotVisited(x,y) || grid[x][y].color != NONE)
						d++;
				}while((!areValidNotVisited(x,y) || grid[x][y].color != NONE) && d<4);
					
				if(d<4){
					grid[point.first][point.second].move = dir[d];
					grid[point.first][point.second].visited = true;
					point.first += DIFFS[dir[d]].first;
					point.second += DIFFS[dir[d]].second;
					moveRandom = true;
					// cout << "single move to " << point.first << " " << point.second << endl;		
				}
			}
		}
	}while(moveBlack || moveWhite || moveRandom);

}


////// Caso rettangolare //////

int rmin, rmax, cmin, cmax;

bool tryRectangle(){
    /*
    Se la soluzione è un rettangolo, il percorso cercato è identificato da quattro punti: (r0,c0),(r1,c1),(r2,c2),(r3,c3)
    (r0,c0) --- (r1,c1)
       |           |
       |           |
    (r2,c2) --- (r3,c3)
    dove: r0 = r1 = rmin, c0 = c2 = cmin, c1 = c3 = cmax, r2 = r3 = rmax.
	*/

    int r0 = rmin, r1 = rmin, c0 = cmin, c2 = cmin, c1 = cmax, c3 = cmax, r2 = rmax, r3 = rmax;
    if(grid[r0][c0].color == WHITE || grid[r1][c1].color == WHITE || grid[r2][c2].color == WHITE || grid[r3][c3].color == WHITE )
    	return false;
    if(grid[r0+1][c0].color == BLACK || grid[r0][c0+1].color == BLACK)
    	return false;
    if(grid[r1+1][c1].color == BLACK || grid[r1][c1-1].color == BLACK)
    	return false;
    if(grid[r2-1][c2].color == BLACK || grid[r2][c2+1].color == BLACK)
    	return false;
    if(grid[r3-1][c3].color == BLACK || grid[r3][c3-1].color == BLACK)
    	return false;

    for(int j = c0+2; j<=c1-2; j++){
    	if(grid[r0][j].color != NONE || grid[r2][j].color != NONE)
    	return false;
    }

    for(int i = r0+2; i<=r2-2; i++){
    	if(grid[i][c0].color != NONE || grid[i][c1].color != NONE)
    	return false;
    }
    
    string sol = "";
    for(int i = c0; i<c1; i++) sol += "R";
    for(int i = r0; i<r2; i++) sol += "D";
    for(int i = c0; i<c1; i++) sol += "L";
    for(int i = r0; i<r2; i++) sol += "U";
    
    out << B+W << " " << sol.size() << " " << r0 << " " << c0 << " " << sol << "#" << endl;
    return true;

}

int main (){

    in >> N >> M >> B >> W;

    grid.resize(N, vector<nodo>(M));

    rmin = N, rmax = -1, cmin = M, cmax = -1;
    for(int i = 0; i<B; i++){
    	int r, c;
        in >> r >> c;
        grid[r][c].color = BLACK;
        rmin = min(rmin,r);
    	cmin = min(cmin,c);
    	rmax = max(rmax,r);
    	cmax = max(cmax,c);
    }
    for(int i = 0; i<W; i++){
    	int r, c;
        in >> r >> c;
        grid[r][c].color = WHITE;
        rmin = min(rmin,r);
    	cmin = min(cmin,c);
    	rmax = max(rmax,r);
    	cmax = max(cmax,c);
    }

	bool solved = false;
	solved = tryRectangle();

	if(!solved){
	    int colorPoint = 0, maxColorPoint = 0;
	    int x, y; // start
	    pair<int,int> point, arrive;

	    while(maxColorPoint < B+W){
	    	for(int i = 0; i<N; i++){
	    		for(int j = 0; j<M; j++){
	    			grid[i][j].move = NONE;
	    			grid[i][j].visited = false;
	    		}
	    	}
	    	solved = false;
	    	colorPoint = 0;
	    	int x, y; // start
		    do{
		    	x = myengine()%N, y = myengine()%M;
		    }while(grid[x][y].color != NONE);

			point = make_pair(x,y);
			solve(point);
			arrive = point; // point è stato aggiornato all'ultimo punto visto
			point = make_pair(x,y);
				
		    string path = "";
		    while(point.first != arrive.first || point.second != arrive.second){
				if(grid[point.first][point.second].color != NONE)
				    colorPoint++;
				int d = grid[point.first][point.second].move;
				point.first += DIFFS[d].first;
				point.second += DIFFS[d].second;
				path += fromIntToDirection[d];
			}

			if(colorPoint>maxColorPoint){
				out << colorPoint << " " << path.size() << " " << x << " " << y << " " << path << "#" << endl << endl;
				// cout << colorPoint << " " << path.size() << " " << x << " " << y << " " << path << "#" << endl << endl;
			   	maxColorPoint = colorPoint;
	    	}
	    }
	}

    return 0;
}